//////////////////////////////
// sequence.wdl
//////////////////////////////
//////////////////////////////
// Winter Contest Project v2.01a, (C) 04, phosphor games, Johannes Bausch
//////////////////////////////
//////////////////////////////
// Demosequenz
//////////////////////////////

//////////////////////////////
// Beateinstellungen / Bibliothek
//////////////////////////////
//var fps_min = 5;
//var fps_max = 10;

define correction 0.317;//0.092;
define bpm 92;

string sndBg = <track-1.wma>;

var volume;
//var _offset;
var_nsave music;
var elapsed_time_ms;

//////////////////////////////
// gibt die Position im Lied zurck
var beat;
//var d_beat;

function setBeat()
{
//	_offset = total_ticks;
	
	timer();
	
	while (1)
	{
		//beat = ( (total_ticks - _offset) / 16 * ((bpm + correction) / 60));
		beat = (elapsed_time_ms / 1000 / 60) * (bpm + correction) - 0.3;
		
		wait(1);
		
		elapsed_time_ms += timer() / 1000;
	}
}

ifdef develop;
	//Beat Panel
	panel pBeat
	{
		//	bmap = blendmap2;
		pos_x = 0;
		pos_Y = 20;
		layer = 20;
		
		digits = 10, 20, 3.2, ftDebug, 1, beat;
		//		digits = 10, 40, 3.2, ftDebug, 1, d_beat;
		digits = 10, 60, 5.2, ftDebug, 1, elapsed_time_ms;
		
		flags = d3d, refresh, visible;
	}
endif;

//////////////////////////////
// startet die Musik

function start_music()
{	
	setBeat();

	ifndef nomusic;
		music = media_play(sndBg, null, volume);
	endif;
	
	if (music)
	{
		while (volume < 100)
		{
			media_tune(music, volume, 0, 0);
			volume += time;
			
			wait(1);
		}
	}
}

function music_min()
{
	if (!music)
	{
		return;
	}
	
	volume = max(1, volume - 10);
	media_tune(music, volume, 0, 0);
}

function music_max()
{
	if (!music)
	{
		return;
	}
	
	volume = min(100, volume + 10);
	media_tune(music, volume, 0, 0);
}

on_f12 = music_min;
on_f11 = music_max;

//////////////////////////////
// Intro (Text & Logos)
//////////////////////////////
bmap bmpLogoA6 = <a6logo.tga>;
panel panLogoA6
{
	bmap = bmpLogoA6;
	layer = 10;
	flags = d3d, refresh;
}

// Bildschirmanzeigen
string strIntro;
string strIntroSmall;
font ftIntroBig = "Arial", 1, 32;
font ftIntroSmall = "Arial", 0, 28;
//font ftDebug = "OCR A Extended", 0, 12;

text txtIntro
{
	font = ftIntroBig;
	layer = 10;
	
	string = strIntro;
	alpha = 0;
	
	flags = center_x, transparent, visible;
}

text txtIntroSmall
{
	font = ftIntroSmall;
	layer = 10;
	
	string = strIntroSmall;
	alpha = 0;
	
	flags = center_x, transparent, visible;
}

function showText(str1, str2, stay, blend)
{
	var ofbeat;

	str_cpy(strIntro, str1);
	str_cpy(strIntroSmall, str2);
	
	txtIntro.alpha = 0;
	txtIntroSmall.alpha = 0;
	
	ofbeat = beat + blend;
	while ( beat < ofbeat )
	{
		txtIntro.alpha = 100 - (ofbeat - beat) / (blend / 100);
		txtIntroSmall.alpha = 100 - (ofbeat - beat) / (blend / 100);
		
		wait(1);
	}
	
	//sleep_block
	ofbeat = beat + stay;
	while ( beat < ofbeat )
	{ wait(1); }

	ofbeat = beat + blend;
	while ( beat < ofbeat )
	{
		txtIntro.alpha = (ofbeat - beat) / (blend / 100);
		txtIntroSmall.alpha = (ofbeat - beat) / (blend / 100);
		
		wait(1);
	}
	
	txtIntro.alpha = 0;
	txtIntroSmall.alpha = 0;
}
//////////////////////////////
//Kamera-Fading Modus
bmap bmpBlack = <black.tga>;

panel pnlFade
{
	pos_x = 0;
	pos_y = 0;
	layer = 5;
	alpha = 100;
	
	bmap = bmpBlack;
	
	ifndef run;
		flags = d3d, refresh, transparent;
	ifelse;
		flags = d3d, refresh, transparent, visible;
	endif;
	
	scale_x = 16;
	scale_y = 16;
}

function fade_panel(in, stay, out)
{
	var ofbeat;
	pnlFade.visible = on;
	
	//in
	if (in > 0)
	{
		ofbeat = beat + in;
		while ( beat < ofbeat )
		{
			pnlFade.alpha = (ofbeat - beat) / (in / 100);
			
			wait(1);
		}
	}
	
	pnlFade.alpha = 0;
	
	//sleep_block
	ofbeat = beat + stay;
	while ( beat < ofbeat )
	{ wait(1); }
	
	if (out > 0)
	{
		ofbeat = beat + out;
		while ( beat < ofbeat )
		{
			pnlFade.alpha = 100 - (ofbeat - beat) / (out / 100);
			
			wait(1);
		}
	}
	pnlFade.alpha = 100;
}

function inv_fade_panel(in, stay, out)
{
	var ofbeat;
	pnlFade.visible = on;
	
	//in
	if (in > 0)
	{
		ofbeat = beat + in;
		while ( beat < ofbeat )
		{
			pnlFade.alpha = 100 - (ofbeat - beat) / (in / 100);
			
			wait(1);
		}
	}
	
	pnlFade.alpha = 100;
	
	//sleep_block
	ofbeat = beat + stay;
	while ( beat < ofbeat )
	{ wait(1); }
	
	if (out > 0)
	{
		ofbeat = beat + out;
		while ( beat < ofbeat )
		{
			pnlFade.alpha = (ofbeat - beat) / (out / 100);
			
			wait(1);
		}
	}
	
	pnlFade.alpha = 0;
}

///////////////////////////////////////////
// Intro-Sequenz
function intro()
{
	var ofbeat;
	
	inv_fade_panel(0, 8, 24);
	
	// A6-Logo
	if (screen_size.x < 800)
	{
		panLogoA6.scale_x = screen_size.x / 800;
		panLogoA6.scale_y = screen_size.y / 600;
	}

	panLogoA6.pos_x = screen_size.x / 2 - 400 * panLogoA6.scale_x;
	panLogoA6.pos_y = screen_size.y / 2 - 300 * panLogoA6.scale_y;
	
	
	panLogoA6.visible = on;
	
	//sleep_block
	ofbeat = int(beat) + 8;
	while ( beat < ofbeat )
	{ wait(1); }
	
	panLogoA6.visible = off;

	// Introtexte
	txtIntro.pos_x = screen_size.x / 2;
	txtIntro.pos_y = screen_size.y / 2 - 200;
	txtIntroSmall.pos_x = screen_size.x / 2;
	txtIntroSmall.pos_y = screen_size.y / 2 - 150;
	
	showText("phosphor games", "proudly presents", 4, 2);
	//sleep_block
	ofbeat = int(beat) + 8;
	while ( beat < ofbeat )
	{ wait(1); }

	showText("a 3D GameStudio techdemo", "presenting the A6 terrain engine", 4, 2);
	//sleep_block
	ofbeat = int(beat) + 8;
	while ( beat < ofbeat )
	{ wait(1); }

	showText("lean back...", "... and enjoy!", 4, 2);
	//sleep_block
	ofbeat = int(beat) + 8;
	while ( beat < ofbeat )
	{ wait(1); }
}

//////////////////////////////
// 1. Sequenz (0:00 - 2:30)
//////////////////////////////

define END_INTRO	32;

define START_SEQ1	32;
define END_SEQ1		272;

define START_D1	32;
define END_D1	64;

define START_D2	64;
define END_D2	112;

define START_D3	112;
define END_D3	144;

define START_D4	144;
define END_D4 208;

define START_D5	208;
define END_D5 272;

//define END_OUTRO 304;
//////////////////////////////
// Hilfsfunktion; gibt eine zufllige Kameraposition zurck
SVEC v_01;

function random_pos(&v)
{
	//Generiert eine zufllige Position
	v_01[0] = 3000 - random(6000);
	v_01[1] = 3000 - random(6000);
	v_01[2] = 2000;

	trace_mode = ignore_sprites + ignore_passable + ignore_passents;
	trace(v_01[0], vector(v_01[0], v_01[1], -2000));
	v[0] = target[0];
	v[1] = target[1];
	v[2] = target[2] + 200;
}

//////////////////////////////
// Hilfsfunktion; gibt eine zufllige Position in der Nhe von u an
function near_pos(&u, d)
{
	var p;
	p = 1;
	
	trace_mode = ignore_passable + ignore_passents;
	while (p > 0)		
	{
		//Zuflliger Punkt in der nhe, distanz
		vec_set(v_01.x, vector(d, 0, 0));
		vec_rotate(v_01.x, vector(random(360), random(40)-20, 0));
		
		//Trace-ursprung
		vec_add(v_01.x, u);
		
		p = trace(u, v_01.x);
	}
	
	vec_set(u, target.x);
}

//////////////////////////////
// Terrain fr Sequenz 1
action aTerrain1
{
	//	vec_scale(my.size, 15);
	//	my.z -= 300;
	
	ifndef nomultitex;
		if (d3d_mode < 3)
		{
			my.material = mtlTerrain2;
		}
		
		else
		{
			my.material = mtlTerrain1;
		}
	ifelse;
		my.material = mtlTerrain2;
	endif;
}

//////////////////////////////
// Sequenz 1

function d1()
{
	//Nchste zufllige position
	random_pos(camera.x);
	
	//nchster zuflliger Winkel		
	vec_set(camera.pan, vector(random(360), 10 - random(40), 0));
	
	//Faden
	fade_panel(0.5, 2, 1.5);
}

SVEC v_02;
SVEC step;
function d2()
{
	var ofbeat;
	
	//Zuflliger startpunkt
	random_pos(v_02);
	
	//Richtung
	vec_set(temp, v_02);
	near_pos(temp, random(200) + 200);
	vec_sub(temp, v_02);
	vec_scale(temp, 1/64);
	vec_set(step, temp);
	
	vec_set(camera.x, v_02.x);

	//nchster zuflliger Winkel		
	vec_set(camera.pan, vector(random(360), 10 - random(40), 0));
	
	//faden
	fade_panel(0.5, 2, 1.5);
	
	//bewegen
	//sleep_block
	ofbeat = int(beat) + 4;
	while ( beat < ofbeat )
	{
		vec_set(temp.x, step.x);
		vec_scale(temp.x, time);
		vec_add(camera.x, temp.x);
		wait(1);
	}
}

function d3()
{
	var ofbeat;
	
	pnlFade.visible = off;
	//1
	//Zuflliger punkt
	random_pos(temp.x);
	vec_set(camera.x, temp.x);
	
	//nchster zuflliger Winkel		
	vec_set(camera.pan, vector(random(360), 10 - random(40), 0));

	//sleep_block
	ofbeat = int(beat) + 1;
	while ( beat < ofbeat )
	{ wait(1); }

	//2
	//Zuflliger punkt
	random_pos(temp.x);
	vec_set(camera.x, temp.x);
	
	//nchster zuflliger Winkel		
	vec_set(camera.pan, vector(random(360), 10 - random(40), 0));

	//sleep_block
	ofbeat = int(beat) + 1;
	while ( beat < ofbeat )
	{ wait(1); }
	
	//3
	//Zuflliger startpunkt
	random_pos(v_02);
	
	//Richtung
	vec_set(temp.x, v_02.x);
	near_pos(temp.x, random(200) + 150);
	vec_sub(temp.x, v_02.x);
	vec_scale(temp.x,1/32);
	vec_set(step.x, temp.x);
	
	vec_set(camera.x, v_02.x);

	//nchster zuflliger Winkel		
	vec_set(camera.pan, vector(random(360), 10 - random(40), 0));
	
	//faden
	fade_panel(0, 0, 2);
	
	//bewegen
	//sleep_block
	ofbeat = int(beat) + 2;
	while ( beat < ofbeat )
	{
		vec_set(temp.x, step.x);
		vec_scale(temp.x, time);
		vec_add(camera.x, temp.x);
		wait(1);
	}
	
}

SVEC astep;
function d4()
{
	var ofbeat;
	
	//Zuflliger startpunkt
	random_pos(v_02);
	
	//Richtung
	vec_set(temp.x, v_02.x);
	near_pos(temp.x, random(200) + 150);
	vec_sub(temp.x, v_02.x);
	vec_scale(temp.x, 1/64);
	vec_set(step.x, temp.x);
	
	vec_set(camera.x, v_02.x);

	//nchster zuflliger Winkel		
	vec_set(camera.pan, vector(random(360), 10 - random(40), 0));
	
	astep.pan = -3 + random(6);
	astep.tilt = -1 + random(2);
	astep.roll = -0.2 + random(0.4);
	
	//faden
	fade_panel(1, 2, 1);
	vec_set(step.x, temp.x);
	
	//Drehung
	astep.pan = -3 + random(6);
	astep.tilt = -1 + random(2);
	astep.roll = -1 + random(2);

	//nchster zuflliger Winkel		
	vec_set(camera.pan, vector(random(360), 10 - random(40), 0));
	
	//bewegen und drehen
	//sleep_block
	ofbeat = int(beat) + 4;
	while ( beat < ofbeat )
	{
		//Position
		vec_set(temp.x, step.x);
		vec_scale(temp.x, time);
		vec_add(camera.x, temp.x);

		//Winkel
		vec_set(temp.pan, astep.pan);
		vec_scale(temp.pan, time);
		vec_add(camera.pan, temp.pan);
		
		wait(1);
	}
}

SVEC v_03;
function d5()
{
	var ofbeat;

	//1
	//Zuflliger startpunkt
	random_pos(v_02);
	
	//Richtung
	vec_set(temp.x, v_02.x);
	near_pos(temp.x, random(200) + 1000);
	vec_sub(temp.x, v_02.x);
	vec_scale(temp.x, 1/64);
	vec_set(step.x, temp.x);
	
	//Drehung
	astep.pan = -3 + random(6);
	astep.tilt = -1 + random(2);
	astep.roll = 0;

	//nchster zuflliger Winkel		
	vec_set(camera.pan, vector(random(360), 10 - random(40), 0));
	
	//faden
	fade_panel(2, 1.5, 0.5);

	//bewegen und drehen
	//sleep_block
	ofbeat = int(beat) + 4;
	while ( beat < ofbeat )
	{
		//Position
		vec_set(temp.x, step.x);
		vec_scale(temp.x, time);
		vec_add(camera.x, temp.x);

		//Winkel
		vec_set(temp.pan, astep.pan);
		vec_scale(temp.pan, time);
		vec_add(camera.pan, temp.pan);
		
		wait(1);
	}
	
	//2
	//Zuflliger punkt
	random_pos(temp.x);
	vec_set(camera.x, temp.x);
	
	//nchster zuflliger Winkel		
	vec_set(camera.pan, vector(random(360), 10 - random(40), 0));

	//faden
	fade_panel(1.75, 0, 0.25);
	
	//sleep_block
	ofbeat = int(beat) + 2;
	while ( beat < ofbeat )
	{ wait(1); }

	//2
	//Zuflliger punkt
	random_pos(temp.x);
	vec_set(camera.x, temp.x);
	
	//nchster zuflliger Winkel		
	vec_set(camera.pan, vector(random(360), 10 - random(40), 0));

	//faden
	fade_panel(0.25, 0, 1.75);
	
	//sleep_block
	ofbeat = int(beat) + 2;
	while ( beat < ofbeat )
	{ wait(1); }
}

//////////////////////////////
// Outro
//////////////////////////////
function outro()
{
	var ofbeat;
	
	// Outrotexte
	txtIntro.pos_x = screen_size.x / 2;
	txtIntro.pos_y = screen_size.y / 2 - 200;
	txtIntroSmall.pos_x = screen_size.x / 2;
	txtIntroSmall.pos_y = screen_size.y / 2 - 150;
	
	fade_panel(2, 8, 14);
	
	showText("this demo was brought to you", "by phosphor games", 4, 2);
	//sleep_block
	ofbeat = int(beat) + 8;
	while ( beat < ofbeat )
	{ wait(1); }

	showText("demo code & graphics", "by phosphor games", 4, 2);
	//sleep_block
	ofbeat = int(beat) + 8;
	while ( beat < ofbeat )
	{ wait(1); }

	showText("music track", "by Oleg (Shytan) Bojczuk", 4, 2);
	//sleep_block
	ofbeat = int(beat) + 8;
	while ( beat < ofbeat )
	{ wait(1); }

	showText("thanks", "for watching", 4, 2);
	//sleep_block
	ofbeat = int(beat) + 8;
	while ( beat < ofbeat )
	{ wait(1); }

	showText("bye.", "", 4, 2);
	//sleep_block
	ofbeat = int(beat) + 8;
	while ( beat < ofbeat )
	{ wait(1); }
	
	sleep(2);

	showText("", " 2004, phosphor games,\nhttp://home.arcor.de/phgames", 4, 2);
	//sleep_block
	ofbeat = int(beat) + 8;
	while ( beat < ofbeat )
	{ wait(1); }
	
	sleep(2);
	
	exit;
}


//////////////////////////////
// Sequenz
//////////////////////////////
function start_seq()
{
	var ofbeat;
	var seq_len;
	
	init_environment1();
	while (!loaded)
	{ wait(1); }
	
	//Kamera-Korrektion
	//STC
	_cam();
	
	sleep(2);
	start_music();
	
	intro();
	//sleep_block
	ofbeat = int(beat) + END_INTRO;
	while ( beat < ofbeat )
	{ wait(1); }
	
	while (beat < END_SEQ1)
	{
		if ( (beat > START_D1) && (beat <= END_D1) )
		{
			seq_len = 4;
			d1();
		}
		
		if ( (beat > START_D2) && (beat <= END_D2) )
		{
			seq_len = 4;
			d2();
		}
		
		if ( (beat > START_D3) && (beat <= END_D3) )
		{
			seq_len = 4;
			d3();
		}
		
		if ( (beat > START_D4) && (beat <= END_D4) )
		{
			seq_len = 4;
			d4();
		}

		if ( (beat > START_D5) && (beat <= END_D5) )
		{
			seq_len = 8;
			d5();
		}
		
		//sleep_block
		ofbeat = int(beat) + seq_len;
		while ( beat < ofbeat )
		{ wait(1); }
	}
	
	//	sleep(1);
	
	//	media_pause(music);
	outro();
	/*	//sleep_block
	ofbeat = int(beat) + END_OUTRO;
	while ( beat < ofbeat )
	{ wait(1); }*/
}

ifdef develop;
	on_space = start_music;
endif;